OBJ
  fant  : "sw_fantasia_drv_002.spin"

CON
    _clkmode = xtal1 + pll8x
    _xinfreq = 10_000_000 + 0000
    _stack = 60
    COGS = 6

VAR
    long    rnd
    word    tv_status_ptr
'    byte    colors[70]
    long    deltax[fant#NUMBER_OF_PARTICLES],deltay[fant#NUMBER_OF_PARTICLES]
    long    bounced[fant#NUMBER_OF_PARTICLES]    
    
PUB Main | i,j,chroma,luma

    fant.Start(COGS,@tv_status_ptr)

    rnd:=$24559f37
    Wait(300)
    repeat
        fant.SetString(0,$180,$200,string("Welcome to..."),10,3)
        Wait(180)
        fant.SetString(1,$380,$600,string("F"),0,3)
        Wait(2)
        fant.SetString(2,$480,$600,string("a"),2,3)
        Wait(2)
        fant.SetString(3,$580,$600,string("n"),4,3)
        Wait(2)
        fant.SetString(4,$680,$600,string("t"),6,3)
        Wait(2)
        fant.SetString(5,$780,$600,string("a"),8,3)
        Wait(2)
        fant.SetString(6,$880,$600,string("s"),10,3)
        Wait(2)
        fant.SetString(7,$980,$600,string("i"),12,3)
        Wait(2)
        fant.SetString(8,$a80,$600,string("a"),14,3)
        Wait(2)
        fant.SetString(9,$b80,$600,string("!"),0,3)
        Wait(10)
        fant.DeltaStringColor(0,0,-1)
        Wait(30)
        fant.DeltaStringColor(0,0,-1)
        Wait(30)
        fant.DeltaStringColor(0,0,-1)
        Wait(30)
        fant.DeleteString(0)
        Wait(180)
        fant.SetString(1,$0,$0,   string("F"),0,2)
        fant.SetString(2,$100,$0, string("a"),2,2)
        fant.SetString(3,$200,$0, string("n"),4,2)
        fant.SetString(4,$300,$0, string("t"),6,2)
        fant.SetString(5,$400,$0, string("a"),8,2)
        fant.SetString(6,$500,$0, string("s"),10,2)
        fant.SetString(7,$600,$0, string("i"),12,2)
        fant.SetString(8,$700,$0, string("a"),14,2)
        fant.SetString(0,$900,$0, string("is a"),10,1)
        fant.SetString(9,$0,$200, string("TV driver for"),10,1)
        fant.SetString(10,$0,$400,string("displaying"),10,1)
        fant.SetString(11,$0,$600,string("text."),10,1)
        Wait(100)
        fant.SetString(12,$0,$600,string("text.."),10,1)
        Wait(100)
        fant.SetString(13,$0,$600,string("text..."),10,1)
        Wait(200)
        fant.SetString(0,$0,$600, string(" and particles."),10,1)
        fant.DeleteStrings(1,13)
        Wait(100)
        repeat i from 0 to fant#NUMBER_OF_PARTICLES-1
            fant.SetParticle(i,(?rnd&$FF)<<4,(?rnd&$FF)<<4,((?rnd&$0f)<<4) + ?rnd&$3 + 11)
            Wait(1)
        Wait(200)
        fant.DeleteString(0)
        fant.SetString(1,$0,$0,   string("F"),0,2)
        fant.SetString(2,$100,$0, string("a"),2,2)
        fant.SetString(3,$200,$0, string("n"),4,2)
        fant.SetString(4,$300,$0, string("t"),6,2)
        fant.SetString(5,$400,$0, string("a"),8,2)
        fant.SetString(6,$500,$0, string("s"),10,2)
        fant.SetString(7,$600,$0, string("i"),12,2)
        fant.SetString(8,$700,$0, string("a"),14,2)
        fant.SetString(9,$0,$200, string("supports an 86"),10,1)
        fant.SetString(10,$0,$400,string("color display."),10,1)
        Wait(200)
        fant.SetString(0,$900,$0, string(" "),10,1)
        fant.SetString(9,$0,$200, string("displays text"),10,1)
        fant.SetString(10,$0,$400,string("and particles on"),10,1)
        fant.SetString(11,$0,$600,string("the fly so does"),10,1)
        fant.SetString(12,$0,$800,string("not need a frame"),10,1)
        fant.SetString(13,$0,$a00,string("buffer."),10,1)
        Wait(300)
        fant.SetString(0,$900,$0, string("doesn't"),10,1)
        fant.SetString(9,$0,$200, string("use a tile map  "),10,1)
        fant.SetString(10,$0,$400,string("so text can be"),10,1)
        fant.SetString(11,$0,$600,string("displayed"),10,1)
        fant.SetString(12,$0,$800,string("anywhere on the"),10,1)
        fant.SetString(13,$0,$a00,string("screen."),10,1)
        Wait(180)
        repeat 5
            repeat i from $00 to $200 step 16
                Wait(1)
                fant.MoveStringBy(12,0,+4)    
                fant.MoveStringBy(13,0,+8)    
            repeat i from $00 to $200 step 16
                Wait(1)
                fant.MoveStringBy(12,0,-4)
                fant.MoveStringBy(13,0,-8)
        Wait(60)
        fant.SetString(0,$0,$0,  string("(Well almost."),10,1)
        fant.SetString(1,$0,$200,string(" Horizontal"),10,1)
        fant.SetString(2,$0,$400,string(" granularity is"),10,1)
        fant.SetString(3,$0,$600,string(" 4 pixels"),10,1)
        fant.SetString(4,$0,$800,string(" for efficiency"),10,1)
        fant.SetString(5,$0,$a00,string(" reasons.)"),10,1)
        fant.DeleteString(6)
        fant.DeleteString(7)
        fant.DeleteString(8)
        fant.DeleteString(9)
        fant.DeleteString(10)
        fant.DeleteString(11)
        fant.DeleteString(12)
        fant.DeleteString(13)
        Wait(120)
        repeat 3
            repeat i from $00 to $600 step 32
                Wait(1)
                fant.MoveStringBy(3,32,0)
            repeat i from $00 to $600 step 32
                Wait(1)
                fant.MoveStringBy(3,-32,0)
        Wait(60)
        fant.SetString(9,$0,$e00,   string("Smooth vertical"),10,1)
        fant.SetString(10,$0,$1000,string("scrolling is one"),10,1)
        fant.SetString(11,$0,$1200,string("thing that you"),10,1)
        fant.SetString(12,$0,$1400,string("could do with"),10,1)
        fant.SetString(0,$000,$1600,string("F"),0,3)
        fant.SetString(1,$100,$1600,string("a"),2,3)
        fant.SetString(2,$200,$1600,string("n"),4,3)
        fant.SetString(3,$300,$1600,string("t"),6,3)
        fant.SetString(4,$400,$1600,string("a"),8,3)
        fant.SetString(5,$500,$1600,string("s"),10,3)
        fant.SetString(6,$600,$1600,string("i"),12,3)
        fant.SetString(7,$700,$1600,string("a"),14,3)
        fant.SetString(8,$800,$1600,string("!"),0,3)
        fant.SetString(13,$0,$1a00, string("Maybe you could"),10,1)
        fant.SetString(14,$0,$1c00, string("do the credits"),10,1)
        fant.SetString(15,$0,$1e00, string("for a game this"),10,1)
        fant.SetString(16,$0,$2000, string("way?"),10,1)
        fant.SetString(17,$0,$3000,  string("       Or"),8,2)
        fant.SetString(18,$80,$3200, string("   a rubbish"),8,2)
        fant.SetString(19,$80,$3400, string(" 2D version of"),8,2)
        fant.SetString(20,$80,$3600, string(" the Star Wars"),8,2)
        fant.SetString(21,$80,$3800, string(" introduction?"),8,2)
        repeat i from 0 to 550
            Wait(1)
            repeat j from 0 to 21
                fant.MoveStringBy(j,0,-16)
        InitStarField
        repeat i from 0 to 400
            repeat j from 0 to 21
                fant.MoveStringBy(j,0,-16)
            DoStarField
        InitWaterfall
        repeat 100
            DoWaterfall($fff,$fff,$fff,$fff,True)                
        fant.SetString(0,$380,$600,string("F"),0,3)
        fant.SetString(1,$480,$600,string("a"),2,3)
        fant.SetString(2,$580,$600,string("n"),4,3)
        fant.SetString(3,$680,$600,string("t"),6,3)
        fant.SetString(4,$780,$600,string("a"),8,3)
        fant.SetString(5,$880,$600,string("s"),10,3)
        fant.SetString(6,$980,$600,string("i"),12,3)
        fant.SetString(7,$a80,$600,string("a"),14,3)
        fant.SetString(8,$b80,$600,string("!"),0,3)
        repeat i from 9 to 21
            fant.DeleteString(i)
        repeat 200 
            DoWaterfall($380,$c80,$680,$780,True)                
        repeat 100
            DoWaterfall($fff,$fff,$fff,$fff,True)                
            repeat i from 0 to 8
                fant.MoveStringBy(i,lookupz(i:-15,+20,-5,+30,-25,9,-10,15,-20),lookupz(i:1,-15,20,-5,10,17,-15,20,-10))
        repeat 150
            DoWaterfall($fff,$fff,$fff,$fff,False)                
            repeat i from 0 to 8
                fant.MoveStringBy(i,lookupz(i:-15,+20,-5,+30,-25,9,-10,15,-20),lookupz(i:1,-15,20,-5,10,17,-15,20,-10))
        fant.DeleteParticles(0,fant#NUMBER_OF_PARTICLES-1)
    
PRI Wait(aFrames) | target
    {{
    Waits for a time specified in TV frames (60 per second)
    }}
    repeat aFrames
        long[tv_status_ptr]:=0
        repeat until long[tv_status_ptr]>0

PRI InitStarfield | i, div, x, y, c
    repeat i from 0 to fant#NUMBER_OF_PARTICLES-1
        div:=(?rnd&$7F)+1
        fant.GetParticle(i,@x,@y,@c)
        deltax[i]:=(x-$800)/div
        deltay[i]:=(y-$700)/div

PRI DoStarField | i, div, x_word_ptr, y_word_ptr, c_word_ptr
    fant.GetParticlePtrs(0,@x_word_ptr,@y_word_ptr,@c_word_ptr)
    repeat i from 0 to fant#NUMBER_OF_PARTICLES-1
        word[x_word_ptr]+=deltax[i]
        word[y_word_ptr]+=deltay[i]
        if word[x_word_ptr]<0 or word[x_word_ptr]>$FFF or word[y_word_ptr]<0 or word[y_word_ptr]>$DFF
            div:=?rnd&$7F
            word[x_word_ptr]:=(?rnd&$FF)<<4
            word[y_word_ptr]:=(?rnd&$FF)<<4
            deltax[i]:=(word[x_word_ptr]-$800)/div
            deltay[i]:=(word[y_word_ptr]-$700)/div
        x_word_ptr+=4        
        y_word_ptr+=4        

PRI InitWaterfall | i
    repeat i from 0 to fant#NUMBER_OF_PARTICLES-1
        deltax[i]:=(?rnd&$7)-4
        deltay[i]:=0
        bounced[i]:=FALSE

PRI DoWaterfall(aX1,aX2,aY1,aY2,aRegenerate) | i,  x_word_ptr, y_word_ptr, c_byte_ptr
    fant.GetParticlePtrs(0,@x_word_ptr,@y_word_ptr,@c_byte_ptr)
    repeat i from 0 to fant#NUMBER_OF_PARTICLES-1
        word[x_word_ptr]+=deltax[i]
        word[y_word_ptr]+=deltay[i]
        if word[y_word_ptr]>aY1 and word[y_word_ptr]<aY2
            if not bounced[i]
                if word[x_word_ptr]>aX1 and word[x_word_ptr]<aX2
                    deltay[i]:=-(deltay[i]>1)-?rnd&$1f
                    bounced[i]:=TRUE
        deltay[i]+=1
        if word[x_word_ptr]>$FFF or word[y_word_ptr]<0 or word[y_word_ptr]>$DFF
            if aRegenerate
                word[x_word_ptr]:=(?rnd&$FF)<<4
                word[y_word_ptr]:=0 '(?rnd&$FF)<<4
                deltax[i]:=(?rnd&$7)-4
                deltay[i]:=(?rnd&$7)+2
                bounced[i]:=FALSE
            else
                byte[c_byte_ptr]:=0
        x_word_ptr+=4        
        y_word_ptr+=4
        c_byte_ptr++        
                   